<?php
/*
feed.php
Version: 1
Desarrollado por: Upgrade Diseño Interactivo
Objetivo - Extraer la información de los eventos, noticias y torneos para mostrarlos en la página principal de la app.
Consulta: Varias tablas según parametros POST
	[A] CROPS			PRINCIPAL    ( CROP A, CROP B, CROP C )
	[B] ROOMS    		SECUNDARIO 	 ( ROOM A, ROOM B, ROOM C )
	[C] Data    		Genera la lista de registros posibles según la fase del room	unit_id y valor de la unidad (oz,gal,litres.)
	[D] Data Units 		SELECT  		Tipo de unidad: 	 1: Data, 2: Catalog, 3: subprocess
	[E] Insert Record	INSERT  		Inserta el registro en la tabla app_values3_tb


Desarrollador: Selene Herrera 
Fecha: 27 diciembre 2021

*/

// config
//$rootPath = 'https://upgrade.red/app_mushroom';
$rootPath = 'https://mushroomproduction.org/sudi/mobile_app/';


require_once("../_sudiEngine/_engine/config.php");
/* Conexión a Base de datos */
include_once("../../../".$root_folder."/connectMySql.php");
/* Funciones PHP */
include_once("../../../".$root_folder."/sudi_functions.php");


$debug = false;


if($debug == true){

$_POST['crops_list'] = true;
$_POST['client'] = 'upgrade';
$_POST['mail'] = 'selene@foodsafetycts.com';
$_POST['user_id'] = 8;



// var_dump($_POST['crops_list']);
// var_dump($_POST['client']);
// var_dump($_POST['mail']);
// var_dump($_POST['user_id']);

}

	// $db = $_COOKIE['db_client'];
  	$login_client_company = $_POST['client'];

	// $m = $_COOKIE['user_mail'];
  	$m = $_POST['mail'];


  		if(isset($login_client_company) && $login_client_company != NULL){


	    if(isset($login_client_company)){
	        $db_client = $login_client_company;
	       	// $_SESSION['client'] = $_COOKIE['cli_db_name'];
	
	    }

	   
		$hostname_connectMySql = "localhost";

	    $sql = 'SELECT * from sudi_clients_tb where cli_db_name = "'. $db_client.'" LIMIT 1';
	    $result = mysqli_query($GLOBALS['connectMySql'], $sql);
	    $client_data = mysqli_fetch_assoc($result);

	    $database_connectMySql = "mushroom_" . $client_data['cli_db_name'] . "_db";
	    $username_connectMySql = "mushroom_" . $client_data['cli_db_user'];
	    $password_connectMySql = $client_data['cli_db_pass'];

	    //unset($connection);
	  

	    $connectMySqluser = new mysqli($hostname_connectMySql, "mushroom_" . $client_data['cli_db_user'], $client_data['cli_db_pass'], "mushroom_" . $client_data['cli_db_name']  . "_db");
	    $GLOBALS['connectMySqluser'] = $connectMySqluser;
	    if (mysqli_connect_errno()) {
	        echo "error";
	        printf("Conexi&oacute;n fallida: %s\n", mysqli_connect_error());
	        exit();
	    }

	  
	}



/*     
	   
	        ***********                            
	        ***********                            
	        ***     ***                            
	        ***     ***                            
	        ***     ***                            
	        ***********                            
	        ***********                            
	        ***     ***                       
            ***     ***                      
            ***     ***               
 */


// [A] CROPS 
	// #Genera la lista de CROPS
	// #Se activa: Si existe "POST - crops_list"

if($_POST['crops_list']){
	  $jsondata = array();
	  /* C O D E */
	  $jsondata['crops']=array();
	  $user_id = $_POST['user_id'];

			
		$query_rsData = sprintf("SELECT crop_id, c_build_id, c_label, c_number, c_folio, c_active,
		c_app_users, user_add, date_add, hideField 
		FROM mh_crops_tb 
		WHERE hideField = 0 
		AND c_active = 0
		AND c_app_users LIKE %s  
		ORDER BY c_label ASC" , '"%['.$user_id .']%"');	

	//AND c_app_users LIKE %s    , '"%['.$user_id .']%"'
	// var_dump($query_rsData);
	// exit;

		$rsData = mysqli_query($connectMySqluser,$query_rsData);
		$row_rsData = mysqli_fetch_assoc($rsData);
		$totalRows_rsData = mysqli_num_rows($rsData);

		do{
				array_push($jsondata['crops'],array(
				'id'=>$row_rsData['crop_id'],
				'name'=>$row_rsData['c_label'],
				'folio' =>  $row_rsData['c_folio']

				));

		}while($row_rsData = mysqli_fetch_assoc($rsData));

		header('Content-type: application/json; charset=utf-8');
	  	echo json_encode($jsondata);
	  	// echo $query_rsData;
		exit();
		

}

/*     
	   
	     *********                      
	     **********                       
	     ***     ***                                 
	     ***    ***                               
	     *********                                   
	     *********                                 
	     ***     ***                                  
	     ***      ***                            
         ***********                          
         **********                  
 */

// [B] ROOMS 
	// #Genera la lista los crooms 
	// #Se activa: Si existe "POST - croom_list"
	if($_POST['croom_list']){
		  $jsondata = array();
		  /* C O D E */
		  $jsondata['croom']=array();
		  $user_id = $_POST['user_id'];
		  $crop = $_POST['crop'];
		  $folio = $_POST['folio'];

			$query_rsData = sprintf("SELECT * 
			FROM mh_crooms_tb as cr

			INNER JOIN app_phases_tb
            ON app_phases_tb.phase_id = cr.croom_step
            
            INNER JOIN mh_crops_tb 
            ON mh_crops_tb.crop_id = cr.croom_crop_id
            
			WHERE cr.hideField = 0 
            AND cr.croom_crop_id = %s
            AND cr.croom_app_users LIKE %s
			ORDER BY croom_label ASC", $crop , '"%['.$user_id .']%"' );

			$rsData = mysqli_query($connectMySqluser,$query_rsData);
			$row_rsData = mysqli_fetch_assoc($rsData);
			$totalRows_rsData = mysqli_num_rows($rsData);

			if($totalRows_rsData){
				do{
						array_push($jsondata['croom'],array(
						'id'=>$row_rsData['croom_id'],
						'name'=>$row_rsData['croom_label'],
						'step' =>  $row_rsData['croom_step'],
						'nstep' =>  $row_rsData['phase_label'],
						'ntrays' =>  'Trays: '.$row_rsData['croom_trays'],

						'nstep_s' =>  $row_rsData['phase_label_spanish'],
						'icon' =>  $row_rsData['phase_icon']
						));

				}while($row_rsData = mysqli_fetch_assoc($rsData));

				header('Content-type: application/json; charset=utf-8');
			  	echo json_encode($jsondata);
			  	// echo $query_rsData;
				//exit();
				
			}else{     //total

				 // 	$jsondata['croom']= '';	
				 // 	header('Content-type: application/json; charset=utf-8');
					// echo json_encode($jsondata);
					// exit;					

				//ver si está en estado start o en estado finish
				$query_rsData2 = "SELECT * FROM app_values3_tb WHERE v_crop_id = ".$crop." AND v_folio like '%".$folio."%'  AND v_comments like '%START PROCESS%' ";
				
				// var_dump($query_rsData2);
				// 	exit;

				$rsData2 = mysqli_query($connectMySqluser,$query_rsData2);
				$row_rsData2 = mysqli_fetch_assoc($rsData2);
				$totalRows_rsData2 = mysqli_num_rows($rsData2);
				
				if($totalRows_rsData2){

				 	$jsondata['croom']= 'FINISH';				
				}else{
					$jsondata['croom']= '';
							

				}

				header('Content-type: application/json; charset=utf-8');
				echo json_encode($jsondata);

			}
	}
	





/*     
	   **********      
	   **********      
	   ***             
	   ***             
	   ***             
	   ***             
	   ***                                        
	   ***                                   
       **********                           
       **********                    
 */

// [C] Data 
	// #Genera la lista de registros posibles según la fase del room
	// #Se activa: Si existe "POST - data_list"
	//quitar cuando este listo subproceso   AND app_datas_tb.type_data != 3;
if($_POST['data_list']){
	// var_dump($_POST);
  $jsondata = array();
  /* C O D E */
  $jsondata['records']=array();

 //  	//hoy
	// $today = date("Y-m-d", strtotime("today"));
	// $today_now = date("Y-m-d H:i:s");

	// , strtotime($date)
	
	$query_rsData = "SELECT * FROM app_datas_tb WHERE data_steps LIKE '%[".$_POST['current_step']."]%'  AND hideField = 0;";
	$rsData = mysqli_query($connectMySqluser,$query_rsData);
	if($rsData){
		$row_rsData = mysqli_fetch_assoc($rsData);
		$totalRows_rsData = mysqli_num_rows($rsData);
	}
	

	// var_dump($query_rsData);
	// exit;
	if($totalRows_rsData){

		
		do{

			$unites = explode('[',$row_rsData['unit_data_id']);
                    $arrayUnites = array();
                    $arrayUnit = array();


                for( $i = 0; $i < sizeof($unites); $i++ ) {
                    if( $unites[$i] > 0 ) {
                        $u = explode(']',$unites[$i]);
                        array_push($arrayUnites,$u[0]);
                    }
                }
   
                for( $i = 0; $i < sizeof($arrayUnites); $i++ ) {
                    $query_rsUnit = sprintf("SELECT unit_value, unit_id FROM app_units_tb WHERE unit_id = %s AND hideField = 0;", $arrayUnites[$i] );
                    						
                    //IN (45,4,52)
                    
                    //debug echo $query_rsService; //exit;
                    $rsUnit = mysqli_query($connectMySqluser,$query_rsUnit);
                    $row_rsUnit = mysqli_fetch_assoc($rsUnit);
                    $totalRows_rsUnit = mysqli_num_rows($rsUnit);

                     if( $totalRows_rsUnit ) { 
				        do {
                  			array_push($arrayUnit,array(
                  			'u_id' => $row_rsUnit['unit_id'],
                  			'u_value' => $row_rsUnit['unit_value']));

                  			
				     	} while( $row_rsProduct = mysqli_fetch_assoc($rsUnit) ); }

                    //$arrayUnit .= $row_rsUnit['unit_value'] . ', ';

                  
                }

                	/*Si está Done el record*/
                		//hoy
						$today = date("Y-m-d", strtotime("today"));
						$today_now = date("Y-m-d H:i:s");



						$query_rsData2 = sprintf("select * FROM app_values3_tb WHERE app_values3_tb.v_folio like '%s' AND v_crop_id = %s AND v_croproom_id = %s AND v_phase = %s AND v_data = %s AND date_add between '%s' AND '%s' ORDER BY date_add DESC LIMIT 1",  $_POST['current_fcrop'], 
							$_POST['current_crop'], 
							$_POST['current_croom'] , 
							$_POST['current_step'],
							$row_rsData['data_id'] , 
							 $today.' 00:00:00', $today_now);

						$rsData2 = mysqli_query($connectMySqluser,$query_rsData2);
						$row_rsData2 = mysqli_fetch_assoc($rsData2);
						$totalRows_rsData2 = mysqli_num_rows($rsData2);
					  //echo $query_rsData2;
						if($totalRows_rsData2){

							array_push($jsondata['records'],array(
							'id'=>$row_rsData['data_id'],
							'name'=>$row_rsData['data_label'],
							'name_spanish'=>$row_rsData['dbl_label_spanish'],
							'units'=> $arrayUnit,
							'done' => '1'
							));
						}else{

							array_push($jsondata['records'],array(
							'id'=>$row_rsData['data_id'],
							'name'=>$row_rsData['data_label'],
							'name_spanish'=>$row_rsData['dbl_label_spanish'],
							'units'=> $arrayUnit,
							'done' => '0'
							));


						}

                	/*end Si está Done el record*/

			
		}while($row_rsData = mysqli_fetch_assoc($rsData));
		mysqli_data_seek($rsData,0);
		$row_rsData=mysqli_fetch_assoc($rsData);
	}
	
	
  	header('Content-type: application/json; charset=utf-8');
  	echo json_encode($jsondata);
	exit();
}



/*     
	   
	   ********                               
	   **********                                
	   ***     ***                                
	   ***     ***                                 
	   ***     ***
	   ***     ***                                
	   ***     ***                       
       **********                            
       ********                     
 */


// [D] Data Units
	// #Genera la lista de las unidades del record selecionado
	// #Se activa: Si existe "POST - data_units"
if($_POST['data_units']){

  $jsondata = array();
  
  $jsondata['units']=array();

	$query_rsData = "SELECT * FROM app_datas_tb WHERE data_id = '".$_POST['current_units']."';";
	
	//echo $query_rsData;
	$rsData = mysqli_query($connectMySqluser,$query_rsData);
	if($rsData){
		$row_rsData = mysqli_fetch_assoc($rsData);
		$totalRows_rsData = mysqli_num_rows($rsData);
	}
	//var_dump($rsData);

	if($totalRows_rsData){
		do{

				switch ($row_rsData['type_data']) {

				case 1:
					//TIPO 1 si el dato es tipo Data
	                $fav_unit =  $row_rsData['fav_unit'];

	                if( $fav_unit  == ''){

					 	$jsondata['units'] =  0;
					 
					
					}else{
					if( $_POST['current_units']  == 16  || $_POST['current_units']  == 20){

		                $arrayUnites = array();
	                    $arrayUnit = array();


	                    $query_rsUnit = sprintf("SELECT unit_value, unit_id FROM app_units_tb WHERE unit_id = %s AND hideField = 0;", $fav_unit );

	                    $rsUnit = mysqli_query($connectMySqluser,$query_rsUnit);
	                    $row_rsUnit = mysqli_fetch_assoc($rsUnit);
	                    $totalRows_rsUnit = mysqli_num_rows($rsUnit);

	                    if( $totalRows_rsUnit ) { 
					        do {
            				$query_rsBed = sprintf("SELECT * FROM mh_crops_tb WHERE crop_id = %s AND hideField = 0;",$_POST['current_r']);

	                    	$rsBed = mysqli_query($connectMySqluser,$query_rsBed);
	                    	$row_rsBed = mysqli_fetch_assoc($rsBed); 
            				$totalRows_rsBed = mysqli_num_rows($rsBed);
							for ($a = 1; $a <= $row_rsBed['c_beds']; $a++) {
                            	// $bed .=  '<option value="'.$a.'"> Probe '.$a.'</option>';
                            	$bed .=  '<div style="margin: auto; display: flex;  flex-direction: column; justify-content: center; align-items: center;"><p style="margin: 0; width: 53%;">Probe '.$a.'</p><div style="display: flex; justify-content: center;"><ons-input class="input_test" name="'.$a.'" type="number" inputmode="decimal" style="width: 35%;margin: 15px 0 !important;">
							      <input type="number" class="text-input" id="input_test" inputmode="decimal" >
							      <span class="text-input__label"></span>
							    </ons-input><input class="unit" style="font-size: 1.3em;text-align: center;line-height: inherit; width: 20%;" value="'.$row_rsUnit['unit_value'].'" disabled=""></div><br><br>';

                            }
                                
                if ( $totalRows_rsBed  ) { 
                    do { 


								array_push($jsondata['units'],array(
	                  			'u_id' => $row_rsUnit['unit_id'],
	                  			'u_value' => $row_rsUnit['unit_value'],
	                  			'u_type' => $row_rsData['type_data'],
	                  			'u_data' => $_POST['current_units'],
	                  			'u_bed' => $bed));
                    

                    } while ($row_rsBed = mysqli_fetch_assoc($rsBed)); }
					        
//current_d
//					        
	                  			
					     	} while( $row_rsProduct = mysqli_fetch_assoc($rsUnit) ); 
					    }
					
					}else{
		                $arrayUnites = array();
	                    $arrayUnit = array();


	                    $query_rsUnit = sprintf("SELECT unit_value, unit_id FROM app_units_tb WHERE unit_id = %s AND hideField = 0;", $fav_unit );

	                    $rsUnit = mysqli_query($connectMySqluser,$query_rsUnit);
	                    $row_rsUnit = mysqli_fetch_assoc($rsUnit);
	                    $totalRows_rsUnit = mysqli_num_rows($rsUnit);

	                    if( $totalRows_rsUnit ) { 
					        do {
	                  			array_push($jsondata['units'],array(
	                  			'u_id' => $row_rsUnit['unit_id'],
	                  			'u_value' => $row_rsUnit['unit_value'],
	                  			'u_data' => $_POST['current_units'],
	                  			'u_type' => $row_rsData['type_data'],
	                  			'u_min' => $row_rsData['data_min'],
	                  			'u_max' => $row_rsData['data_max']


	                  		));

					     	} while( $row_rsProduct = mysqli_fetch_assoc($rsUnit) ); 
					    }
					}
					}
					/*FIN TIPO 1 */
					break;

					case 2:
					/*TIPO 2 si el dato es tipo catálogo			todos los id de los catalogos van a ser a partir cat_id 	1000 */

					$query_rsIndexCatalogs = sprintf("SELECT * FROM mh_catalogs_tb WHERE cat_id = '".$row_rsData['data_unit_id']."' AND hideField = 0;" );
					

					$rsIndexCatalogs = mysqli_query($connectMySqluser,$query_rsIndexCatalogs);
	               	$row_rsIndexCatalogs = mysqli_fetch_assoc($rsIndexCatalogs);
	                $totalRows_rsIndexCatalogs = mysqli_num_rows($rsIndexCatalogs);


	                if( $totalRows_rsIndexCatalogs ) { 

	                	//se construye una consulta para traer el catálogo correspondiente Ej. Supplement, Compost, etc.
	                	//SELECT * FROM cat_table WHERE hideField = 0

	                	$query_rsCatalog = sprintf("SELECT * FROM %s WHERE 1 and hideField = 0;", $row_rsIndexCatalogs['cat_table']);
						//echo  $query_rsCatalog;

	                	$rsCatalog = mysqli_query($connectMySqluser,$query_rsCatalog);
	                    $row_rsCatalog = mysqli_fetch_assoc($rsCatalog);
	                    $totalRows_rsCatalog = mysqli_num_rows($rsCatalog);

	                    //var_dump($row_rsCatalog);

		                    if( $totalRows_rsCatalog ) { 
						        do {
		                  			array_push($jsondata['units'],array(
		                  			'u_id' => $row_rsCatalog['cat_id'],
		                  			'u_value' => $row_rsCatalog['cat_value'],
		                  			'u_type' => $row_rsData['type_data'],
		                  			'u_data' => $_POST['current_units'],
		                  			'u_catid' => $row_rsData['data_unit_id']) );

						    	} while( $row_rsCatalog = mysqli_fetch_assoc($rsCatalog) ); 
						    }
	                } //cierre if $totalRows_rsIndexCatalogs
	                break;
					/*FIN TIPO 2*/


					//TIPO 3 si el dato es tipo SUBPROCESO
					case 3:

			

						array_push($jsondata['units'],array(
		                  			'u_type' => '3',
		                  			'u_serializa' => $row_rsData['data_serialize'] ));
					//FIN TIPO 3

					break;   

 
					//TIPO 4 si el dato es tipo Híbrido   u_unit_id
					case 4:


					$query_rsIndexCatalogs = sprintf("SELECT * FROM mh_catalogs_tb WHERE cat_id = '".$row_rsData['data_unit_id']."' AND hideField = 0;" );
					

					$rsIndexCatalogs = mysqli_query($connectMySqluser,$query_rsIndexCatalogs);
	               	$row_rsIndexCatalogs = mysqli_fetch_assoc($rsIndexCatalogs);
	                $totalRows_rsIndexCatalogs = mysqli_num_rows($rsIndexCatalogs);


	                if( $totalRows_rsIndexCatalogs ) { 

	                	//se construye una consulta para traer el catálogo correspondiente Ej. Supplement, Compost, etc.
	                	//SELECT * FROM cat_table WHERE hideField = 0

	                				// $query_rsUnit = sprintf("SELECT unit_value, unit_id FROM app_units_tb WHERE unit_id = %s AND hideField = 0;", $fav_unit );

				                 //    $rsUnit = mysqli_query($connectMySqluser,$query_rsUnit);
				                 //    $row_rsUnit = mysqli_fetch_assoc($rsUnit);
				                 //    $totalRows_rsUnit = mysqli_num_rows($rsUnit);

	                	$query_rsCatalog = sprintf("SELECT * FROM %s WHERE hideField = 0;", $row_rsIndexCatalogs['cat_table']);
						//echo  $query_rsCatalog;

	                	$rsCatalog = mysqli_query($connectMySqluser,$query_rsCatalog);
	                    $row_rsCatalog = mysqli_fetch_assoc($rsCatalog);
	                    $totalRows_rsCatalog = mysqli_num_rows($rsCatalog);

	                    //var_dump($row_rsCatalog);

		                    if( $totalRows_rsCatalog ) { 

		                    		$valor_temp = $row_rsCatalog['cat_value'];

								    	/*
								    	//agregue el id de la unit 
			                			'u_unit_id' =>   $row_rsData['fav_unit'];
										
										array_push($jsondata['units'],array(
				                  			$fav_unit ));
								    	*/

								        do {
				                  			array_push($jsondata['units'],array(
				                  			'u_id' => $row_rsCatalog['cat_id'],
				                  			'u_value' => $row_rsCatalog['cat_value'],
				                  			'u_type' => $row_rsData['type_data'],
				                  			'u_data' => $_POST['current_units'],
				                  			'u_catid' => $row_rsData['data_unit_id'],
				                  			'u_unit_id' => $row_rsData['fav_unit']) );

								    	} while( $row_rsCatalog = mysqli_fetch_assoc($rsCatalog) ); 
		                    	}


						    


						    
	                } //cierre if $totalRows_rsIndexCatalogs

					//FIN TIPO 4

					break;   
	        }
			
		}while($row_rsData = mysqli_fetch_assoc($rsData));
		mysqli_data_seek($rsData,0);
		$row_rsData=mysqli_fetch_assoc($rsData);
	}
	
  	header('Content-type: application/json; charset=utf-8');
  	echo json_encode($jsondata);
	exit();
}

/*     
	   **********      
	   **********      
	   ***             
	   ***             
	   *******             
	   *******             
	   ***             
	   ***             
       **********      
       **********      

 */

// [E] Insert Record
// insert_record
if($_POST['insert_record']){

		  $jsondata = array();
		  $jsondata['response']=array();
		  $arraySubprocess = array();  
			
			//insert_record : true, double : current_double, record : current_record, data : last_data
		  	// el v_type_unit nos indica 1: Data, 2: Catalog, 3: subprocess
		  	// el v_fav_unit indica el id de la tabla 
		  	// DATA 	Ejemplo 	WATERING	 type : 1, v_unit_id = 12 (data_id),  v_fav_unit = 0 
		  	// CATALOG  Ejemplo		SUPPLEMENT 	 type : 2, v_unit_id =  4 (data_id),  v_fav_unit = 0 
		  	$double_id =  $_POST['double'];
			$insert_unitCat = ($_POST['unit_cat']) ? $_POST['unit_cat'] :'0';   //si es tipo Catalog recibe el post, sino es tipo Data 0
			$insert_bed = ($_POST['bed']) ? $_POST['bed'] :'0';   //si el data es id 16 or 20 recibe el post, sino es tipo Data 0
			
			//comentarios adicionales
			$v_comments = $_POST['v_comments']; 

			//subprocesos
			$insert_length = ($_POST['sub_length']) ? $_POST['sub_length'] :'';   //si recibimos el post, sino es 0 (Sólo el tipo subprocesso tiene valores: 1,2,3)
			$insert_color = ($_POST['sub_color']) ? $_POST['sub_color'] :'';   //si recibimos el post, sino es 0 (Sólo el tipo subprocesso tiene valores: 1,2,3)
			$insert_squeeze = ($_POST['sub_squeeze']) ? $_POST['sub_squeeze'] :'';   //si recibimos el post, sino es 0 (Sólo el tipo subprocesso tiene valores: 1,2,3)
			$insert_density = ($_POST['sub_density']) ? $_POST['sub_density'] :'';   //si recibimos el post, sino es 0 (Sólo el tipo subprocesso tiene valores: 1,2,3)

			//si es el record (22) CO2  tiene la nomenclatura 1.0 entonces multiplica por 10,000
			//sino déjalo como lo envian
				if ($_POST['record'] == 22){
					if($_POST['data'] < 99){
						$data = ($_POST['data'] * 10000);
					}else{  //como lo envían
						$data = ($_POST['data']) ? $_POST['data'] :''; 	
					}
					
				}else{
					$data = ($_POST['data']) ? $_POST['data'] :''; 
				}


			//recibe el id   del valor del catálogo
			$insert_value_cat = $_POST['value_cat'];
			$supplier = 22;
			// $insert_value_cat = ($_POST['value_cat']) ? $_POST['value_cat'] : 0;
			if($_POST['type'] == 1){
				$insert_unit = ($_POST['unit']) ? $_POST['unit'] : 0;
			}

			//si el type es diferente a (2) catalogo entonces toma la unidad que se le manda
			if($_POST['type'] == 2){
				$insert_unit = ($_POST['unit']) ? $_POST['unit'] : 0;
			}


			if($_POST['type'] == 4){
			//si el type es (2) catalogo entonces haz el siguiente if
				//si es el record (35) Harvest agregale a la unidad que sea pounds (unit_id 31)
				if ($_POST['record'] == 35){
					$insert_unit = 31;
				}
				
				//si es el record (12) Watering agregale a la unidad que sea gallons (unit_id 7)
				if ($_POST['record'] == 12){
					$insert_unit = 7;
				}

				//si es el record (9) Fly Count agregale a la unidad que sea units (unit_id 4)
				if ($_POST['record'] == 9){
					$insert_unit = 4;
				}

				//si es el record (29) Pest incindence agregale a la unidad que sea units (unit_id 38)
				if ($_POST['record'] == 29){
					$insert_unit = 38;
				}

				//si es el record (33) Post steaming agregale a la unidad que sea units (unit_id 24)
				if ($_POST['record'] == 33){
					$insert_unit = 24;
				}

				//si es el record (71) Empty steaming agregale a la unidad que sea units (unit_id 24)
				if ($_POST['record'] == 71){
					$insert_unit = 24;
				}
			}
			
			if($_POST['type'] == 3){
				$insert_unit = ($_POST['unit']) ? $_POST['unit'] : 0;
			}

			//tiempo del dispositivo
		  	$time =  $_POST['date'];

		  		if (($insert_length == '') && ($insert_color == '') && ($insert_squeeze == '') && ($insert_density == '')) {
					$ser_subp =  '';
				}else{
				 	array_push($arraySubprocess,array(
				            'length' =>  $insert_length,
				            'color' =>   $insert_color,
				            'squeeze' => $insert_squeeze,
				            'density' => $insert_density
				    ));

				 	$ser_subp = serialize($arraySubprocess);
				    
			 	}

//INSERT INTO `app_values3_tb`
		  	//(`v_id`, `v_crop_id`, `v_croproom_id`, `v_unit_id`, `v_unit2_id`, `v_value_cat`, `v_unit_cat_id`, `v_type_unit`, `v_phase`, `v_folio`, `v_serial_sub`, `v_data`, `v_value`, `v_bed`, `v_comments`, `v_type_compost`, `user_add`, `date_add`, `hideField`) VALUES ([value-1],[value-2],[value-3],[value-4],[value-5],[value-6],[value-7],[value-8],[value-9],[value-10],[value-11],[value-12],[value-13],[value-14],[value-15],[value-16],[value-17],[value-18],[value-19])


//( `v_unit_id`, `v_unit2_id`, `v_value_cat`, `v_unit_cat_id`, `v_type_unit`, `v_phase`, `v_folio`, `v_serial_sub`, `v_data`, `v_value`, `v_bed`, `v_comments`, `v_type_compost`, `user_add`, `date_add`, `hideField`)
									$query_rsData = sprintf("INSERT INTO app_values3_tb 
									(v_crop_id, 
									v_croproom_id,
									v_v_croproom_id_old,
									v_unit_id, 									
									v_value_cat,										
									v_unit_cat_id,
									v_type_unit,
									v_phase, 
									v_folio,
									v_serial_sub,

									v_data,

									v_value,

									v_bed,
									v_comments,
									v_type_compost,
									user_add,
									date_add) 
									
										VALUES 

									(%s, 
									%s,
									%s, 
									%s,
									%s,
									%s,
									%s, 
									'%s',
									'%s',
									'%s',

									%s,

									%s,

									%s,
									'%s',
									%s,
									%s,
									'%s')", 

									$_POST['crop'], 
									$_POST['room'],
									'0',
									$insert_unit, 
									$insert_value_cat,
									$insert_unitCat,
									$_POST['type'],
									$_POST['step'], 
									$_POST['folio'],
									$ser_subp,

									$_POST['record'],

									$data,

									$insert_bed,
									$v_comments,
									$supplier,
									$_POST['user_id'],
									$time);

									if(mysqli_query($connectMySqluser,$query_rsData)){
										 echo '1';
										 // var_dump($query_rsData);
									}else{
										// echo '0';
										  var_dump($query_rsData);
									}
						

// 		 /*
// 		 $query_rsData = sprintf("INSERT INTO app_values3_tb 
// /*CROP 1   FK mh_crops_tb*/			(v_crop_id, 
// /*ROOM 1   FK mh_croprooms_tb*/		v_croproom_id,
// 									v_v_croproom_id_old,
// /*UNIT 7   Ej.id 7 gallons   */		v_unit_id, 
// /*VALUE CAT 1 Valor del catalogo*/	v_value_cat,
// /*unit cad 2   FK mh_catalogs_tb */	v_unit_cat_id,
// /*type unit 2  Catalog*/			v_type_unit,
// /*phase 5  Spawn Run  */			v_phase, 
// /*Folio fol-00002   */				v_folio,
// /*'[1][2]'   sólo tipo subproceso*/	v_serial_sub,

// /*data 12   FK app_datas_tb*/		v_data,

// /*45   example watering 45*/		v_value,

// /*PROBE 2  numero de bed*/			v_bed,
// /*Notes    comentarios adicionales*/v_comments,
// /*OWN COMPOST 1   FK mh_cat_suppliers_tb*/ v_type_compost,
// /* 2   FK app_users_tb*/			user_add,
// /*2021-09-28  date device*/			date_add) 
									
// 										VALUES 

// /*CROP 1   FK mh_crops_tb*/			(%s, 
// /*ROOM 1   FK mh_croprooms_tb*/		%s,
// /*UNIT 7   Ej.id 7 gallons   */		%s, 
// /*VALUE CAT 1 Valor del catalogo*/	%s,
// /*unit cad 2   FK mh_catalogs_tb */	%s,
// /*type unit 2  Catalog*/			%s,
// /*phase 5  Spawn Run  */			%s, 
// Folio fol-00002   				'%s',
// /*'[1][2]'   sólo tipo subproceso*/	'%s',

// /*data 12   FK app_datas_tb*/		%s,

// /*45   example watering 45*/ 		%s,

// /*PROBE 2  numero de bed*/			%s,
// /*Notes    comentarios adicionales*/'%s',
// /*OWN COMPOST 1   FK mh_cat_suppliers_tb*/%s,
// /* 2   FK app_users_tb*/			%s,
// /*2021-09-28  date device*/			'%s')", 


// //CROP 1   FK mh_crops_tb    		$_POST['crop'], 
// /*ROOM 1   FK mh_croprooms_tb*/		$_POST['room'],
// //									'0',
// /*UNIT 7   Ej.id 7 gallons   */		$insert_unit, 
// /*VALUE CAT 1 Valor del catalogo*/	$insert_value_cat,
// /*unit cad 2   FK mh_catalogs_tb */	$insert_unitCat,
// /*type unit 2  Catalog*/			$_POST['type'],
// /*phase 5  Spawn Run  */			$_POST['step'], 
// /*Folio fol-00002   */				$_POST['folio'],
// /*'[1][2]'   sólo tipo subproceso*/	$ser_subp,

// /*45   example watering 45*/		$_POST['record'],

// /*data 12   FK app_datas_tb*/ 		$data,

// /*PROBE 2  numero de bed*/			$insert_bed,
// /*Notes    comentarios adicionales*/$v_comments,
// /*OWN COMPOST 1   FK mh_cat_suppliers_tb*/$supplier,
// /* 2   FK app_users_tb*/			$_POST['user_id'],
// /*2021-09-28  date device*/			$time);

// */

}






/*     
	   **********      
	   **********      
	   ***             
	   ***             
	   *******             
	   *******             
	   ***             
	   ***             
       ***      
       ***      

 */




// [F] RECORDS CROPS list
	// #Genera la bitácora de CROPS
	// #Se activa: Si existe "POST - recordcrop_list"

if($_POST['recordcrop_list']){
	  $jsondata = array();
	  /* C O D E */
	  $jsondata['bcrops']=array();
	  $user_id = $_POST['user_id'];
	  
	  $crop = $_POST['recordcrop'];

	  $query_rsData = sprintf("SELECT 
	  v.v_id,
	  v.v_crop_id,
	  v.v_croproom_id	, 
	  v.v_unit_id,
	  v.v_unit2_id,	
	  v.v_value_cat,
	  v.v_unit_cat_id	,
	  v.v_type_unit	,
	 v.v_phase	,
	 v.v_folio	,
	 v.v_serial_sub	,
	 v.v_data	,
	 v.v_value	,
	 v.v_bed	,
	 v.v_comments	,
	 v.v_type_compost	,
	 v.user_add	,
	 v.date_add ,
	 v.hideField,	

    c.crop_id,
	c.c_build_id,
	c.c_label,
	c.c_number,
	c.c_folio,
	c.c_beds,
	c.c_app_users,
	c.c_compost,
	c.c_active,
	c.user_add,
	c.hideField,	

	r.croom_id,	
	r.croom_app_users,
	r.croom_label,
	r.croom_step,
	r.user_add,
	r.hideField,
    
   
    p.phase_id,
	p.phase_label,
	p.phase_label_spanish,
	p.phase_icon,
	p.user_add,	
	p.hideField,	

	d.data_id,
	d.data_unit_id,
	d.fav_unit,
	d.type_data,
	d.data_min,
	d.data_max,
	d.data_label,
	d.dbl_label_spanish,
	d.data_steps,
	d.data_serialize,	
	d.hideField 	


      
	  FROM app_values3_tb as v
      
      LEFT JOIN mh_crops_tb c ON c.crop_id = v.v_crop_id
	  LEFT JOIN mh_crooms_tb r ON r.croom_id = v.v_croproom_id
	  LEFT JOIN app_phases_tb p ON p.phase_id = v.v_phase
	  -- LEFT JOIN mh_cat_suppliers_tb s ON s.cat_id = v.v_type_compost
	  LEFT JOIN app_datas_tb d ON d.data_id = v.v_data
      
      WHERE 

      v.v_crop_id = %s AND
      v.hideField = 0 AND
      c.hideField = 0 AND
      r.hideField = 0 AND
      p.hideField = 0 AND
      -- s.hideField = 0 AND
      d.hideField = 0 
      
	  
	  LIMIT %s offset %s",  $crop, $_POST["limit"] , $_POST["start"]);	


	  // ORDER BY v.date_add DESC",  $crop);

	  //var_dump($query_rsData);

		$rsData = mysqli_query($connectMySqluser,$query_rsData);
		$row_rsData = mysqli_fetch_assoc($rsData);
		$totalRows_rsData = mysqli_num_rows($rsData);

							
							
							
		do{
/******************************************************************/
/**************   do while según el type de data           ********/
/******************************************************************/				
		
							// $ho = explode(' ', $row_rsData['date_add']);  
							// $hour = $ho[1];

							// $dat=date_create($ho[0]);
						 //    $date = date_format($dat,"F j, Y");

							// $ho = explode(' ', $row_rsData['date_add']); 

							// $hour = $ho[1];


							// $dat=date_create($row_rsData['date_add']);
							// $dat=date_create($ho[0]);
							// $date = date_format($dat,"F j, Y, g:i a");
							// $date = $row_rsData['date_add'];


// 
					// $date_s=date_create($row_rsData['date_add']);
					// $date = date_format($date_s,"F j, Y, g:i a");

					// $date_s=date_create($row_rsData['date_add']);
					// $date = date_format($date_s,"F j, Y, g:i a");

											   // $date = dateFormatEnglish($row_rsData['date_add'],'/',false);
						     // $ho = explode(' ', $row_rsData['date_add']);  
						     // $hour = $ho[1];
						   //$hour = $ho;
						     // $date = $ho[0];
						     $ho = explode(' ', $row_rsData['date_add']);
						     $date = dateFormatEnglish($ho[0],'', false);
						     $hour = $ho[1];
						     // $hour = $root_folder;
		// $date = $query_rsData;
						   // $dat=date_create($ho[0]);
						   // $date = date_format($dat,"Y-m-d");

// $date = $row_rsData['date_add'];


					
					// $date = date_format($date_s, 'Y-m-d H:i:s');



switch ($row_rsData['v_type_unit']) {
				
				/*TIPO 1 si el dato es tipo Data*/
				case '1':
						// $query_rsUnit = sprintf("SELECT * FROM app_values3_tb as v,  app_units_tb as u, app_users_tb as us , app_phases_tb as p, mh_crooms_tb as cr, app_datas_tb as da, 
						// 									   mh_crops_tb as c
						//  WHERE v.user_add = us.app_user_id 
						//  AND v.v_id = %s 
						//  AND v.v_data = da.data_id
						//  AND u.unit_id = %s 
						//  AND p.phase_id = %s 
						//  AND v.user_add = %s 
						//  AND v.hideField = 0 limit 1;",  $row_rsData['v_id'],$row_rsData['v_unit_id'], $row_rsData['v_phase'],  $row_rsData['user_add']);

						$query_rsUnit = sprintf("SELECT * FROM app_values3_tb as v
												LEFT JOIN app_units_tb as u
											    ON u.unit_id = v.v_unit_id
											    
											    LEFT JOIN app_users_tb as us 
											    ON us.app_user_id = v.user_add
											    
											    LEFT JOIN mh_crooms_tb as cr
											    ON cr.croom_id = v.v_croproom_id
											    
											    LEFT JOIN app_datas_tb as da
											    ON da.data_id = v.v_data
											    
											    LEFT JOIN mh_crops_tb as c
											    ON c.crop_id = v.v_crop_id
											    
											    WHERE 
											 	v.v_id = %s AND v.hideField = 0 limit 1;",  $row_rsData['v_id']);

						// $q = $query_rsUnit;
					 //var_dump($query_rsUnit);


		    	 		$rsUnit = mysqli_query($connectMySqluser,$query_rsUnit);
		                $row_rsUnit = mysqli_fetch_assoc($rsUnit);
// debug
 // var_dump($row_rsUnit);
		                if( $rsUnit ) {

						    $f = $row_rsUnit['v_folio'];
						    
							if( $row_rsData['v_data'] == 16 || $row_rsData['v_data'] == 20){
						     	
						     	$type =  $row_rsData['v_value'] . ' '. $row_rsUnit['unit_value']. ' Probe : '. $row_rsData['v_bed'];

								// $unit = $row_rsUnit['unit_value'];
								$unit = '';


							}else{

								$type = $row_rsData['v_value'] .' '. $row_rsUnit['unit_value'];

								// $unit = $row_rsUnit['unit_value'];
								$unit = '';


								
						    }
					
						}

				/*FIN TIPO 1*/
				break;



				/*TIPO 2 si el dato es tipo catálogo*/
				case '2':
					
					//buscamos en la tabla indexada la relación respecto al tipo de data que es
					$query_rsIndexCatalogs = sprintf("SELECT * FROM mh_catalogs_tb WHERE cat_id = %s AND hideField = 0;", $row_rsData['v_unit_cat_id'] );

					$rsIndexCatalogs = mysqli_query($connectMySqluser,$query_rsIndexCatalogs);
	               	$row_rsIndexCatalogs = mysqli_fetch_assoc($rsIndexCatalogs);
	                $totalRows_rsIndexCatalogs = mysqli_num_rows($rsIndexCatalogs);

	                if( $rsIndexCatalogs ) {

		                //se construye una consulta para traer el catálogo correspondiente Ej. Supplement, Compost, etc.
		                $query_rsCatalog = sprintf("SELECT * FROM %s WHERE  cat_id = %s;", $row_rsIndexCatalogs['cat_table'],  $row_rsData['v_value_cat']);
		                		$q = $query_rsCatalog ;
		                
		                $rsCatalog = mysqli_query($connectMySqluser,$query_rsCatalog);
		                $row_rsCatalog = mysqli_fetch_assoc($rsCatalog);
			                    if( $rsCatalog ) {
			                    	$c = substr($row_rsCatalog['cat_value'], 0, 10);

							    	$type =  $row_rsData['v_value'] .' <div>'. $c . '</div>';


						    		$unit= '';
			                    }else{
			                   		$type = '';
			                   		$unit= '';
			                   	}
	                }
				/*FIN TIPO 2*/
				break;




				//TIPO 3 si el dato es tipo SUBPROCESO   $GLOBALS['connectMySql']
				case '3':
						if ($row_rsData['v_data'] == 73  ) {
							$query_rsSub = sprintf("SELECT * FROM app_values2_tb as v, app_users_tb as us , app_phases_tb as p, mh_doubles_tb as d,
						app_datas_tb as da, mh_cat_suppliers_tb as sup

						WHERE v.user_add = us.app_user_id 
						AND v.v_id = %s 
						AND p.phase_id = %s 
						AND d.dbl_id = %s 
						AND v.user_add = %s 
						AND v.v_data = da.data_id
						AND v.v_type_compost = sup.cat_id
						AND v.hideField = 0;",   $row_rsData['v_id'], $row_rsData['v_phase'], $row_rsData['v_dbl_id'] ,  $row_rsData['user_add'] ); 

						$rsSub = mysqli_query($connectMySqluser,$query_rsSub);
	                	$row_rsSub = mysqli_fetch_assoc($rsSub);

						// $date = dateFormatEnglish($row_rsData['date_add'],'/',false);

							$pinning = ($row_rsData['v_value'] == 1) ? 'No' :'Yes';   
							$type =  $pinning;

						}elseif($row_rsData['v_data'] == 95  ){

									$query_rsSub = sprintf("SELECT * FROM app_values2_tb as v, app_users_tb as us , app_phases_tb as p, mh_doubles_tb as d,
						app_datas_tb as da, mh_cat_suppliers_tb as sup

						WHERE v.user_add = us.app_user_id 
						AND v.v_id = %s 
						AND p.phase_id = %s 
						AND d.dbl_id = %s 
						AND v.user_add = %s 
						AND v.v_data = da.data_id
						AND v.v_type_compost = sup.cat_id
						AND v.hideField = 0;",   $row_rsData['v_id'], $row_rsData['v_phase'], $row_rsData['v_dbl_id'] ,  $row_rsData['user_add'] ); 

						$rsSub = mysqli_query($connectMySqluser,$query_rsSub);
	                	$row_rsSub = mysqli_fetch_assoc($rsSub);
 // var_dump($query_rsSub); 
 						
					

						$arrayFlyCount = array( 1 => "Few",  2 => "Some",3 => "Too Many");
						
						$fly_count = $arrayFlyCount[$row_rsData['v_value']] ;   
					
						$type =  $fly_count;

						$unit= '';

						}


				//FIN TIPO 3

				break;




				/*TIPO 4 si el dato es tipo híbrido*/
				case '4':

					//buscamos en la tabla indexada la relación respecto al tipo de data que es
					$query_rsIndexCatalogs = sprintf("SELECT * FROM mh_catalogs_tb WHERE cat_id = %s AND hideField = 0;", $row_rsData['v_unit_cat_id'] );
		

					$rsIndexCatalogs = mysqli_query($connectMySqluser,$query_rsIndexCatalogs);
	               	$row_rsIndexCatalogs = mysqli_fetch_assoc($rsIndexCatalogs);
	                $totalRows_rsIndexCatalogs = mysqli_num_rows($rsIndexCatalogs);


	                if( $rsIndexCatalogs ) {
		                //se construye una consulta para traer el catálogo correspondiente Ej. Supplement, Compost, etc.
		                $query_rsCatalog = sprintf("SELECT * FROM %s WHERE  cat_id = %s;", $row_rsIndexCatalogs['cat_table'],  $row_rsData['v_value_cat']);

		                $rsCatalog = mysqli_query($connectMySqluser,$query_rsCatalog);
		                $row_rsCatalog = mysqli_fetch_assoc($rsCatalog);

			                    if( $rsCatalog ) {
								
								$query_rsCat = sprintf("SELECT * FROM app_values3_tb as v
												LEFT JOIN app_units_tb as u
											    ON u.unit_id = v.v_unit_id
											    
											    LEFT JOIN app_users_tb as us 
											    ON us.app_user_id = v.user_add
											    
											    LEFT JOIN mh_crooms_tb as cr
											    ON cr.croom_id = v.v_croproom_id
											    
											    LEFT JOIN app_datas_tb as da
											    ON da.data_id = v.v_data
											    
											    LEFT JOIN mh_crops_tb as c
											    ON c.crop_id = v.v_crop_id
											    
											    WHERE 
											 	v.v_id = %s AND v.hideField = 0 limit 1;",  $row_rsData['v_id']);
// AND u.unit_value = %s
							    $q = $query_rsCat;

								$rsCat = mysqli_query($connectMySqluser,$query_rsCat);
		                		$row_rsCat = mysqli_fetch_assoc($rsCat);

						    	
						    	$typ = $row_rsCat['data_label'];

									    	if ($row_rsData['v_unit_cat_id'] == 1014  || $row_rsData['v_unit_cat_id']== 1015) {
													 //si es post o empty steaming agrega su segunda unidad
													$query_rsData2 = sprintf("SELECT *  FROM app_units_tb WHERE app_units_tb.unit_id = %s",$row_rsData['v_unit2_id'] );
															
													$rsData2 = mysqli_query($connectMySql,$query_rsData2);
													$row_rsData2 = mysqli_fetch_assoc($rsData2);
													$totalRows_rsData2 = mysqli_num_rows($rsData2);
										
													$v_unit2_id = $row_rsData2['unit_value'];
												
			  										$type = $row_rsData['v_value'] .' ' .$row_rsCat['unit_value'];

										   			$unit= $row_rsCatalog['cat_value'].' '.$v_unit2_id;


											}else{
													//si el dato y el valor del catálogo
													$value = ($row_rsData['v_value'] == '') ? '0' : $row_rsData['v_value'];   
									   
										   			$type = $value .' ' .$row_rsCat['unit_value'] ;
										   			$unit= $row_rsCatalog['cat_value'];
											}
										  

			                    }else{
			                   		$type = '';
			                   	}       
                    	

	                }


				/*FIN TIPO 4*/
				break;






 

			} //end switch

//data_label":null,"value":null,"unit":null,"folio":null,"date_add":null}





			array_push($jsondata['bcrops'],array(
				'id'=>$row_rsData['v_id'],
				
				'type' => $row_rsData['v_type_unit'],
				'comment' => $row_rsData['v_comments'],

				'v_crop_id'=>$row_rsData['v_crop_id'],

				'c_label'=>$row_rsData['c_label'],

				'croom_label'=>$row_rsData['croom_label'],

				'phase_label'=>$row_rsData['phase_label'],

				'phase_icon'=>$row_rsData['phase_icon'],

				'data_label'=>$row_rsData['data_label'],

				'value'=>$type,
				'unit'=>$unit,

				'folio'=>$row_rsData['v_folio'],
			
				'date_add'=>$date,
				'hour' => $hour
				

					
			));

/******************************************************************/
/**************   END do while según el type de data       ********/
/******************************************************************/	

		}while($row_rsData = mysqli_fetch_assoc($rsData));

		header('Content-type: application/json; charset=utf-8');
	  	echo json_encode($jsondata);
	  	// echo $query_rsData;
		exit();
		

}




?>