<?php

/*

# SUDI_Widget: attendance
# Título: Resumen de asistencia.
# Objetivo: Presentar la actividad del día en materia de asistencia y check-ins de los usuarios
# Creado por: Hugo Acosta
# Fecha: Nov 2016

*/


	/* A - QUERY - Extraemos el listado de los últimos registros de asistencia del área */
	$query_rsInOffice = sprintf("
		SELECT
			at.att_hour, at.att_type, at.att_place, at.map_lat, at.map_long, us.user_fname, us.user_fav_name, us.user_mname, us.user_lname, us.user_photo, us.user_id
		FROM attendance_tb at 
		
		LEFT JOIN sudi_users_tb us 
			ON us.user_id = at.att_user
		
		LEFT JOIN attendance_tb at2 
			ON(at.att_user = at2.att_user AND at.att_id < at2.att_id)
 
		WHERE at2.att_id IS NULL AND at.att_date = %s
		ORDER BY at.att_id DESC;", GetSQLValueString($the_day, 'text'));

		$rsInOffice = mysqli_query($connectMySql,$query_rsInOffice);
		if($rsInOffice){
			$row_rsInOffice = mysqli_fetch_assoc($rsInOffice);
			$totalRows_rsInOffice = mysqli_num_rows($rsInOffice);
		}
	
	// 0 -> Entrada / 1 -> Salida a comer / -> 3 Regreso a comer / 4 -> Salida / 5 -> Checkin
	
		$att_date_type = array('','Entrada','Comida','Regreso','Salida', 'Check-in' );
		$att_date_color = array('','88b65c','ebd912','88b65c','ca4c3d', '00acc8');
		$att_date_arrow = array('','arrow-in-right-3','drink','arrow-repeat-5','arrow-in-left-2-1','iconos-sudi-pin-fill-sharp-circle-2');
?>

	<!-- WIDGET == ON THE OFFICE -->
   	<?php if($totalRows_rsInOffice){ ?> 
    <div class="wid_onoffice_container">
		
    	<div id="wid_onoffice_users">
        	<p id="onoffice_headline">Asistencia de <?php echo dateFormat($hoy,''); ?></p>
			<section id="onoffice_wrapper">
			
			<?php  
				do { 
					
					$datetime1 = date_create($the_day." ".$row_rsInOffice['att_hour']);
					$datetime2 = date_create($current_time);
					$lapse_days = date_diff($datetime1, $datetime2);	
			?>
				<div class="loadRContent" data-target="r_panel" data-post="folder_:__adminAssets/attendance/assets/checkins.php_&_record_:_<?php echo $the_day; ?>_&_userid_:_<?php echo $row_rsInOffice['user_id']; ?>_&_username_:_<?php echo $row_rsInOffice[$fav_name[$row_rsInOffice['user_fav_name']]]; ?>">
                	<span class="wid_onoffice_icon">
						<i class="icon icon-iconos-sudi-<?php echo $att_date_arrow[$row_rsInOffice['att_type']]; ?>" style="color:#<?php echo $att_date_color[$row_rsInOffice['att_type']]; ?>;"></i></span>                
                	<span class="wid_onoffice_time"><?php echo date('g:ia', strtotime($row_rsInOffice['att_hour'])); ?></span>
                    
					<!--<img class="wid_onoffice_img_map" src="https://maps.googleapis.com/maps/api/staticmap?key=AIzaSyB5AWtkSlRhWESvHFLrYW7kG1E1MAE_UWI&&center=<?php echo $row_rsInOffice['map_lat'] . "," . $row_rsInOffice['map_long']; ?>&zoom=15&size=100x100&markers=color:0x88b65c%7c<?php echo $row_rsInOffice['map_lat'] . "," . $row_rsInOffice['map_long']; ?>&sensor=false" width="100" height="100"/>-->
					
					<img 
                    	src="<?php echo (file_exists("../". $row_rsInOffice['user_photo'])) ? $root_webapp_path.$row_rsInOffice['user_photo'] : '_includes/_img/themes/logos/logo_upgrade.svg'; ?>" 
                        alt="<?php echo $row_rsInOffice['user_fname'] . " " . $row_rsInOffice['user_lname']; ?>"
						class="wid_onoffice_img_map <?php
							if($row_rsInOffice['att_type'] == '2'){ echo "user_eating"; }elseif($row_rsInOffice['att_type'] == '4'){ echo "user_out"; }				
						?>"
                    />
					
                    
                    <img 
                    	src="<?php echo (file_exists("../". $row_rsInOffice['user_photo'])) ? $root_webapp_path.$row_rsInOffice['user_photo'] : '_includes/_img/themes/logos/logo_upgrade.svg'; ?>" 
                        alt="<?php echo $row_rsInOffice['user_fname'] . " " . $row_rsInOffice['user_lname']; ?>"
						class="wid_onoffice_img_user <?php
							if($row_rsInOffice['att_type'] == '2'){ echo "user_eating"; }elseif($row_rsInOffice['att_type'] == '4'){ echo "user_out"; }				
						?>"
                    />
                    <!--<span>
						<?php echo $att_date_type[$row_rsInOffice['att_type']]; ?></span>-->
                    <span><?php echo $row_rsInOffice[$fav_name[$row_rsInOffice['user_fav_name']]] . " " . $row_rsInOffice['user_lname']; ?></span>
                   
                      <span class="wid_onoffice_place"><i class="icon icon-iconos-sudi-market-map"></i> <?php echo $row_rsInOffice['att_place']; ?></span>
                        <span><?php echo $row_rsInOffice['att_date_type']; ?></span>
				</div><!--  -->
        	<?php }while($row_rsInOffice = mysqli_fetch_assoc($rsInOffice)); ?>
        	</section><!-- #onoffice_wrapper-->
        </div><!-- #wid_onoffice_users -->
    </div><!-- .wid_onoffice_container -->
    <div id="check_express"><span class="loadContent" data-target="curtain" data-content="_sudiEngine/_engine/manage_engine.php" data-post="folder_:__adminAssets/attendance"><i class="icon icon-sudi-check"></i> Checar asistencia</span></div>
    <?php } ?>