var theToken = 'not_set';  

function onPushwooshInitialized(pushNotification) {

    //if you need push token at a later time you can always get it from Pushwoosh plugin
    pushNotification.getPushToken(function(token) {
      console.info('push token: ' + token);
    }
    );
    
    //and HWID if you want to communicate with Pushwoosh API
    pushNotification.getPushwooshHWID(function(token) {
      console.info('Pushwoosh HWID: ' + token);
    }
    );
    
    //settings tags
    pushNotification.setTags({
      tagName: "tagValue",
      intTagName: 10
    },
    function(status) {
     alert('setTags success: ' + JSON.stringify(status));
   },
   function(status) {
     alert('setTags failed');
   }
   );
    
    pushNotification.getTags(function(status) {
       alert('getTags success: ' + JSON.stringify(status));
     },
     function(status) {
       alert('getTags failed');
     }
     );
    
    //start geo tracking.
    //pushNotification.startLocationTracking();
  }

  function initPushwoosh() {
    var pushNotification = cordova.require("pushwoosh-cordova-plugin.PushNotification");
    
    //set push notifications handler
    document.addEventListener('push-notification',
      function(event) {
        var message = event.notification.message;
        var userData = event.notification.userdata;

	  //dump custom data to the console if it exists
	  if (typeof(userData) != "undefined") {
		console.warn('user data: ' + JSON.stringify(userData));
	  }
	}
	);
    
    //initialize Pushwoosh with projectid: "GOOGLE_PROJECT_ID", appid : "PUSHWOOSH_APP_ID". This will trigger all pending push notifications on start.
    pushNotification.onDeviceReady({
     projectid: "730221191579",
     appid: "7461C-5B287",
     serviceName: ""
   });
    
    //register for push notifications
    pushNotification.registerDevice(
      function(status) {
		  
		theToken = status.pushToken; 
        document.getElementById("pushToken").innerHTML = status.pushToken + "<p>";
        onPushwooshInitialized(pushNotification);
		  alert(status.pushToken);
      },
      function(status) {
        alert("failed to register: " + status);
        console.warn(JSON.stringify(['failed to register ', status]));
      }
      );
  }


  var app = {
    // Application Constructor
    initialize: function() {
      this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
      document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady: function() {
      initPushwoosh();
      app.receivedEvent('deviceready');
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
      var parentElement = document.getElementById(id);
      var listeningElement = parentElement.querySelector('.listening');
      var receivedElement = parentElement.querySelector('.received');

      listeningElement.setAttribute('style', 'display:none;');
      receivedElement.setAttribute('style', 'display:block;');

      console.log('Received Event: ' + id);
    }
  };

  app.initialize();

	$(document).on(clickHandler,'#dev_token',function(){
		alert(theToken);
	});
