<?php
	class input_file {
	/*
	*Clase: Input File
	@return: Selector de imágenes y archivos
	#Desarrollado por: Hugo Acosta
	#Fecha: Septiembre 2015

	*/

		// Propiedades
			/* 1)  Tipo */
			public $type; // <-- 'same' / 'gallery' / 'files'

			/* 2)  Texto*/
			public $text;

			/* 3)  Código único */
			public $code;

			/* 4)  Ruta final */
			public $path;

			/* 5)  Miniatura */
			public $thumb;

			/* 6)  Ancho de miniatura */
			public $thumbWidth;

			/* 7)  Ancho de la imagen */
			public $width;

			/* 8)  Alto de la imagen */
			public $height;

			/* 9)  Recorte de la imagen */
			public $crop;

			/* 10) Calidad de la imagen */
			public $quality;

			/* 11) Cantidad de archivos */
			public $max_files;

			/* 12) Tipos de archivos*/
			public $file_types;

			/* 13) Ancho máximo si es imagen */
			public $max_width;

			/* 14) Alto Máximo si es imagen*/
			public $max_height;

			/* 15) Tabla en la que se guarda*/
			public $table;

			/* 16) Icono del botón para seleccionar el archivo */
			public $icon;

			/* 16) Campo en el que se guarda*/
			public $field;

			/* 17) Acción "add" o "edit"*/
			public $action;

			/* 18) Recorset */
			public $data;

			/* 19) Linked_field -gallery / files - */
			public $linked_field;

			/* 20) Linked_field_id -gallery / files - */
			public $linked_field_id;

			/* 21) Especial:  - */
			public $special;

			/* 22) ID principal (galería)  - */
			public $main_id;

			/* 23) Size */
			public $size;

		function __construct($action_code,$type){
			/**
				* Asignar datos a la variable
				* @return none
			**/

			$this->code = $action_code;
			$this->type = $type;

		}

		function display(){
			/**
				* Mostrar el Input en el DOM
				* @return spry / input
			**/

			// LIMITACIONES GENERALES

				// Si es galería o file, necesita field, table, linked_field

				if($this->type != 'same'){
					if(!$this->field	 || 	!$this->linked_field || !$this->table || !$this->linked_field_id){
						return '<p style="font-size:.7em;"><i style="color:#FF0000;" class="icon icon-iconos-sudi-warning"></i> File - Propiedad faltante "field - linked_field - table"</p>';
					}else{
						$linked_field = 'data-linked="'.$this->linked_field.'"';
						$linked_field_id = 'data-linkedid="'.$this->linked_field_id.'"';
					}
				}else{
					// No se requiere $linked_field
					$linked_field = '';
					$linked_field_id = '';
				}

				// Si no existe la ruta, se corta el input

				if(!$this->path){
					return '<p style="font-size:.7em;"><i style="color:#FF0000;" class="icon icon-iconos-sudi-warning"></i> File - Propiedad faltante "path"</p>';
					exit;
				}else{
					//Nos aseguramos que exista diagonal al final
					$this->path = rtrim($this->path, '/') . '/';
					if(!is_dir('../../'.$this->path)){
						return '<p style="font-size:.7em;"><i style="color:#FF0000;" class="icon icon-iconos-sudi-warning"></i> File - La ruta "'.$this->path.'" no existe.</p>'; exit;
					}
				}
				$temp = $this->path;
				// Si no existe la tabla
				if(!$this->table || !$this->field){
					return '<p style="font-size:.7em;"><i style="color:#FF0000;" class="icon icon-iconos-sudi-warning"></i> File - Propiedad faltante "Table o Field"</p>';
					exit;
				}


				// TIPOS DE ARCHIVO
					$types_ok = '';
					// En Galería
						//accept=".xls,.xlsx"
					if($this->type === 'gallery'){
						$types_ok = 'accept=".jpg,.png,.svg"';
					}elseif($this->file_types){
						$types_ok = 'accept="'.$this->file_types.'"';
					}


			$output = '';

			if(!$this->type){ return $output='<p>No se ha definido el tipo de input_file</p>'; }
				// Limitaciones


					// #1.A) Con CROP: Si se requiere corte CROP y no se tiene el ancho
					if(!$this->width && $this->crop){
						return '<p style="font-size:.7em;"><i style="color:#FF0000;" class="icon icon-iconos-sudi-warning"></i> File - Propiedad faltante: "with"</p>'; exit;
					}


				// Preparamos los parametros

					// #Input especial
					$thisSpecial = ($this->special) ? 'data-special="'.$this->special.'"' : 'data-nospecial=""';

					// ancho de contenedor
					$this->size = ($this->size) ? $this->size : '1x';

					// #Ancho Final
					$thisWidth = ($this->width) ? 'data-width="'.$this->width.'"' : '';

					// #Alto Final
					$thisHeight = ($this->height) ? 'data-height="'.$this->height.'"' : '';

					// #Ancho maximo
					$thisMaxWidth = ($this->max_width) ? 'data-allowedwidth="'.$this->max_width.'"' : '';

					// #Alto maximo
					$thisMaxHeight = ($this->max_height) ? 'data-allowedheight="'.$this->max_height.'"' : '';

					// #Calidad de la imagen
					$thisQuality = ($this->quality) ? 'data-quality="'.$this->quality.'"' : '' ;

					// #Recorte
					$thisCrop = ($this->crop) ? 'data-crop="1"' : 'data-crop="0"';

					// #Miniatura
					$thisThumb = ($this->thumb) ? 'data-thumb="1"' : 'data-thumb="0"';
					// #Ancho miniatura
					$thisThumbWith = ($this->thumbWidth) ? 'data-thumbwidht="'.$this->thumbWidth.'"' : '';


					// EDIT

					if($this->action == 'edit'){

						if($this->type === 'gallery'){

							// Conexión a la base de datos
							$db = Database::getInstance();
							$mysqli = $db->getConnection();

							//Query
							$sql_query = sprintf("SELECT * FROM %s WHERE %s = %s AND hideField = 0", GetSQLValueString( $this->table, "none"),GetSQLValueString( $this->linked_field, "none"),GetSQLValueString( $this->main_id, "int"));
							//$result = $mysqli->query($sql_query);
							$result = mysqli_query($GLOBALS['connectMySql'],$sql_query);
							$row = $result->fetch_assoc();

							if($row){
								do {

									$this->data = $row[$this->field];
									if (strpos($this->data, '/') === false) {
										$this->data = $temp.'/'.$this->data;
									}

									if(file_exists('../../'.$this->data) && !is_dir('../../'.$this->data)){

										$pathInfo = pathinfo($this->data);
											$file_folder = 	$pathInfo['dirname'];
											$file_name = $pathInfo['basename'];
										if(file_exists('../../'.$file_folder.'/min_'.$file_name)){
											$file_path = $file_folder.'/min_'.$file_name;
										}else{
											$file_path  = $this->data;
										}

										$loaded_items .= '
										<div class="loaded_item_row">
											<div class="loaded_img">
												<img src="'.$file_path.'">
											</div>
											<div class="loaded_file_name">
												<p>'.substr($file_name,14).'</p>
											</div>
											<div class="loaded_file_options loaded_edit_file_delete file_delete"
												data-file = "'.substr($file_name,14).'"
												data-field = "'.$this->field.'"
												data-table = "'.$this->table.'"
												data-pathfile="'.$this->data.'">
													<i class="icon icon-iconos-sudi-delete"></i>
											</div>
											<input name="'.$this->field.'" type="hidden" class="spryManage" value="'.$this->data.'">
										</div>
										';

									} // if file exits (end)


								} while($row = mysqli_fetch_assoc($result));
							}
						}else{
							if(file_exists('../../'.$this->data) && !is_dir('../../'.$this->data)){

								$pathInfo = pathinfo($this->data);
									$file_folder = 	$pathInfo['dirname'];
									$file_name = $pathInfo['basename'];
								if(file_exists('../../'.$file_folder.'/min_'.$file_name)){
									$file_path = $file_folder.'/min_'.$file_name;
								}else{
									$file_path  = $this->data;
								}

									$extension = strtolower(substr(('../../'.$this->data),-3)); //Estraemos la extensión

									switch($extension) {
										case 'jpg': case 'png': case 'gif': case 'svg':
											$thisType = 'image';
											break;
										case 'xml': case 'php': case 'html': case 'css': case 'js':
											$thisType = 'code';
											break;
										case 'zip': case 'rar':
											$thisType = 'file-zip-1';
											break;
										case 'ics':
											$thisType = 'calendar';
											break;
										case 'xls': case 'xlsx':
											$thisType = 'xls';
											break;
										case 'ppt': case 'pptx':
											$thisType = 'ppt';
											break;
										case 'doc': case 'docx':
											$thisType = 'docx';
											break;
										case 'pst':
											$thisType = 'pst';
											break;
										case 'pdf':
											$thisType = 'file-pdf';
											break;
										case 'ai': case 'eps':
											$thisType = 'vectors';
											break;
										case 'psd':
											$thisType = 'psd';
											break;
										default:
											$thisType = 'paper';

									}

								$thisThumbnail = ($thisType == 'image') ? '<img src="'.$file_path.'">' : '<i class="icon icon-iconos-sudi-'.$thisType.'"></i>';

								$loaded_items = '
								<div class="loaded_item_row">
									<div class="loaded_img">
										<a href="'.$file_path.'" target="_blank">'.$thisThumbnail.'</a>
									</div>
									<div class="loaded_file_name">
										<p>'.substr($file_name,14).'</p>
									</div>
									<div class="loaded_file_options loaded_edit_file_delete file_delete"
										data-file = "'.substr($file_name,14).'"
										data-field = "'.$this->field.'"
										data-table = "'.$this->table.'"
										data-pathfile="'.$this->data.'">
											<i class="icon icon-iconos-sudi-delete"></i>
									</div>
									<input name="'.$this->field.'" type="hidden" class="spryManage" value="'.$this->data.'">
								</div>
								';

							} // if file exits (end)
						}
					}else{
						$loaded_items = '';
					}

				$output .= '
					<div class="upload_container input_'.$this->size.'">
						<div class="fileName"><div class="files_container blur_effect">'.$loaded_items.'</div>
							<div class="file_loading">
								<div class="div_loading"><div class="loader_wrapper"><div class="spinner"><div class="bounce1"></div><div class="bounce2"></div><div class="bounce3"></div></div></div></div>
							</div>
						</div>
						<div class="upload">
							<p class="upload_text"><i class="icon icon-iconos-sudi-'.$this->icon.'"></i>'.$this->text.'</p>
						<input type="file" name="image_upload" data-type="'.$this->type.'" '.$thisCrop.' '.$thisThumb.' '.$thisThumbWith.' '.$thisWidth.' '.$thisHeight.' '.$thisMaxWidth.''.$types_ok.''.$thisMaxHeight.' '.$thisQuality.' data-path="'.$this->path.'" data-code="'.$this->code.'" data-field="'.$this->field.'" data-table="'.$this->table.'" '.$linked_field .' '.$linked_field_id.' ' . $thisSpecial .' />
						</div>
					</div>
					';



			return $output;
		}
	} // [END CLASS] input_textfield

?>