<?php
/*
	# file_upload.php
	# Versión 1 - SUDI v3.0
	# Septiembre 2015
	# Funciones Básicas de Archivos
		
		Metodos:
		
		[A] delete_file.- Eliminamos el archivo solicitado
		[B] delete_manage_file.- Eliminamos el archivo y el registro de un archivo ya guardado
		Default.- Recibimos archivos de "manage" mediante XMLHttpRequest
	# Desarrollado por Hector Hugo Acosta Garza
*/

require_once("../_sudiEngine/_engine/config.php");

/* Conexión a Base de datos */
include_once("../../../".$root_folder."/connectMySql.php");
/* Funciones PHP */
include_once("../../../".$root_folder."/sudi_functions.php");



// [A] DELETE FILES

	if(isset($_POST['method']) && $_POST['method'] === 'delete_file'){
				
		// a.1 Eliminamos el registro de la bse de datos
		$query_rsDelete = sprintf("DELETE FROM sudi_temp_files WHERE file_path = %s;",GetSQLValueString(substr($_POST['pathfile'], 3),'text'));
		
		if(mysqli_query($connectMySql,$query_rsDelete)){
						
			// a.2 Si existe el archivo en el servidor, lo eliminamos
			if (file_exists($_POST['pathfile'])){
				if(unlink($_POST['pathfile'])){
					
					// a.3 Eliminar miniatura si existe
					$thumbnail = substr($_POST['pathfile'], 0, strrpos($_POST['pathfile'], "/"));
					$thumbnail = $thumbnail."/min_".$_POST['file'];
					if (file_exists($thumbnail)){ unlink($thumbnail); }
					echo "success";
				}else{
					echo "unsuccess";	
				}
			}else{
				echo "unsuccess_2s";	
			}
		}
	exit;
	}// if [delete_file] (end)
	

// [B] DELETE MANAGE FILES {method : 'delete_manage_file', field : thisField, pathfile : thisPathFile, table : thisTable}


if(isset($_POST['method']) && $_POST['method'] === 'delete_manage_file'){
	// a.1 Eliminamos el registro de la bse de datos
	
		$query_rsDelete = ($_POST['field'] == 'gallery_file') ? sprintf("DELETE FROM %s WHERE %s = %s;", $_POST['table'], $_POST['field'], GetSQLValueString($_POST['pathfile'],'text')) : sprintf("UPDATE %s SET %s = '', hideField = 1 WHERE %s = %s;", $_POST['table'], $_POST['field'], $_POST['field'], GetSQLValueString($_POST['pathfile'],'text'));
	
		if(mysqli_query($connectMySql,$query_rsDelete)){
						
			// a.2 Si existe el archivo en el servidor, lo eliminamos
			if (file_exists('../'.$_POST['pathfile'])){
				if(unlink('../'.$_POST['pathfile'])){
					
					$thumbnail = viewThumb($_POST['pathfile']);
					if (file_exists('../'.$thumbnail)){ unlink('../'.$thumbnail); }
					echo "success";
				}else{
					echo "unsuccess";	
				}
			}else{
				echo "unsuccess_2s";	
			}
		}	
	exit;	
}


// SIN METODO.- se usa para subir un archivo 


	$file_type = $_REQUEST['type']; // <-- 'image' || 'file'
	
		// Parametros de la imagen
		if($file_type == 'image') {
			$img_crop = ($_REQUEST['crop']) ? true : false;
			$img_width = ($img_crop) ? 2500 : $_REQUEST['width'];
			$img_height = ($_REQUEST['crop']) ? 2500 : $_REQUEST['height'];		
		}
			$toMove_path = '../'.$_REQUEST['folder'];
				

		$saveddate = date("mdy-Hms");
	
		$tmp_name = $_FILES["image_upload"]["tmp_name"]; // Tomamos el archivo y le damos un nombre temporal
		$beforUploadFileName = $_FILES["image_upload"]["name"];
		$uploadfilename = strtolower(basename($saveddate."_".str_replace(" ", "", $_FILES["image_upload"]["name"])));
		$uploadfilename = strtolower(basename($saveddate."_".str_replace(" ", "", $_FILES["image_upload"]["name"])));
		$uploadfilename = str_replace('(','',$uploadfilename);
		$uploadfilename = str_replace(')','',$uploadfilename);		
		// Ruta Temporal

		$newfilename = $toMove_path . $uploadfilename; // Establecemos la ruta temporal de la imagen		

		if($beforUploadFileName != "")
		{ // Si realmente existe un archivo
						// Se sube la imagen a la carpeta _temp
			if (move_uploaded_file($tmp_name, $newfilename))
			{	
			// Insertamos el archivo en la tabla de temporales
			$query_rsTempFile =	sprintf("INSERT INTO `sudi_temp_files` (`file_code`, `file_path`) VALUES (%s, %s)", GetSQLValueString($_REQUEST['action_code'], 'text'), GetSQLValueString(substr($newfilename, 3), 'text'));
				mysqli_query($connectMySql,$query_rsTempFile);
				
				$extension = strtolower(substr($uploadfilename,-3)); //Estraemos la extensión 							
				
				if($extension == "jpg" || $extension == "png" || $extension == "gif")
				{ //Comprobamos que sea arvhico de imagen	
									
					//Buscamos la orientación
					if(extension_loaded(exif_read_data)){
						$exif = exif_read_data($src);
						$orientation = $exif['Orientation'];
					}
					if(!$orientation){ $orientation = 1;}
					/* Mniatura */
					if($_REQUEST['thumb']){
						setImageSize($newfilename,'min_'.$uploadfilename,$_REQUEST['thumbWidth'],$img_height,$toMove_path,$extension,$orientation,$_REQUEST['quality']); 
					}
					
					/* Imagen Real (Solo si no hay CROP) */
					
					if(!$img_crop){
						echo setImageSize($newfilename,$uploadfilename,$img_width,$img_height,$toMove_path,$extension,$orientation,$_REQUEST['quality']);	
					}else{
						echo $newfilename; 
					}
									
				}else {
					echo $newfilename; 
				}
				
				
				
				
			}else{
				echo "not_uploaded";	
			}
		}

?>