<?php 

/*
	main_menu.php
		Este archivo es cargado mediante Ajax para generar los vínculos a las secciones en el menú principal del SUDI

*/

// SESSION_START
	if (!isset($_SESSION)) {
		session_name('_upgrade');
		session_start();
	}



require_once("../_sudiEngine/_engine/config.php");
/* Conexión a Base de datos */
include_once("../../../".$root_folder."/connectMySql.php");
/* Funciones*/
include_once("../../../".$root_folder."/sudi_functions.php");


//incluimos la clase "current_user"
require '../_phpClasses/class.CurrentUser.inc';
$thisUser = new current_user;

// requerimos la clase "Privilegios"
require '../_phpClasses/class.Privileges.inc';

//debug
//echo "resultado: " . CheckPrivileges::getPrivileges("R",'7',$thisUser->user_profile); exit;


/* Clase del grupo de navegación */
require "../_phpClasses/class.navGroup.inc";

	// Individuales
	
		// Seleccionamos todas las secciones que contienen un grupo.
		$query_rsSections =
			"SELECT 
				sec_order, sec_id, sec_name, sec_folder, sec_file, sec_icon
			FROM 
				sudi_sections_tb 
			WHERE 
				sec_group = 0
				AND
				sec_status = 1
			ORDER BY
				sec_order";
			$rsSections = mysqli_query($connectMySql,$query_rsSections);
			$row_rsSections = mysqli_fetch_assoc($rsSections);
			$totalRows_rsSections = mysqli_num_rows($rsSections);
	
			if($totalRows_rsSections){
				do{
				
				// Validamos PRIVILEGIO DE LECTURA.
					
					if(CheckPrivileges::getPrivileges("R",$row_rsSections['sec_id'],$thisUser->user_profile) == 1)
					{
											
				// Validamos si es la instrucción especial "list"
				$theFolder = ($row_rsSections['sec_file'] === 'list') ? '_sudiEngine/_engine' : $row_rsSections['sec_folder'];
				$theFile = ($row_rsSections['sec_file'] === 'list') ? 'list_engine.php' : $row_rsSections['sec_file'];
						
			echo '<li class="nav_alone loadContent" data-target="main" data-content="'.$theFolder."/".$theFile.'"  data-post="folder_:_'.$row_rsSections['sec_folder'].'" ><span>'.$row_rsSections['sec_name'].'</span> <i class="icon icon-iconos-sudi-'.$row_rsSections['sec_icon'].' nav_title_icon"></i></li>';
			
					} // END - Validación de privilegios
			
				}while($row_rsSections = mysqli_fetch_assoc($rsSections));
		
			} // If Individual sections (end)
	
	// var_dump($query_rsSections);
	// GRUPOS
		// Seleccionamos todas las secciones que contienen un grupo.
		$query_rsSections =
			"SELECT 
				group_name, group_order, group_icon, sec_order, sec_id, sec_name, sec_folder, sec_file, sec_icon
			FROM 
				sudi_groups_tb, sudi_sections_tb 
			WHERE 
				sec_group = group_id
				AND
				sec_status = 1
			ORDER BY
				group_order, sec_order";
			$rsSections = mysqli_query($connectMySql,$query_rsSections);
			$row_rsSections = mysqli_fetch_assoc($rsSections);
			$totalRows_rsSections = mysqli_num_rows($rsSections);	
	
	
if($totalRows_rsSections){	
	// Creamos el Array que contendrá los botónes.
	
	$group_name = '';
	$menuSections = array();
	$i = -1;

	do{
		
		// Validamos PRIVILEGIO DE LECTURA.
					
			if(CheckPrivileges::getPrivileges("R",$row_rsSections['sec_id'],$thisUser->user_profile) == 1)
					{
		
		//Si es nuevo Array
		if($group_name != $row_rsSections['group_name']){
			$group_name = $row_rsSections['group_name'];
			$i++;	
			array_push($menuSections,array());
				$menuSections[$i]['title'] = $row_rsSections['group_name'];
				$menuSections[$i]['icon'] = $row_rsSections['group_icon'];
				$menuSections[$i]['section'] = array();
		}
					
		$secDat = array(
			'id'		=>	$row_rsSections['sec_id'],
			'name'	=>	$row_rsSections['sec_name'],
			'icon'	=>	$row_rsSections['sec_icon'],
			'folder'	=>	$row_rsSections['sec_folder'],
			'file' 	=>	$row_rsSections['sec_file']
		);	
		array_push($menuSections[$i]['section'], $secDat);
		
					}// End - Validación que contiene grupo
		
	}while($row_rsSections = mysqli_fetch_assoc($rsSections));
	
	foreach ($menuSections as &$value) {
		$createGroup = new navGroup($value);
		echo $createGroup->display();	
	}
}
?>