<?php 
/*
	add_edit.php
	Desarrollado por: Hugo Acosta / Adam Marquez
	Fecha: Agosto 2015
	Desc.- Automatizar el proceso de agregar o editar registros a la base de datos.
	Editado: Ocrubre 2015 [Hugo Acosta]
		Se agregó la función de multiples tablas
		
	Editado: Febrero		
*/

// SESSION_START
	if (!isset($_SESSION)) {
		session_name('_upgrade');
		session_start();
	}

//Elementos para depurar
$debug = false;
$debug_queries = false;

if($debug && $debug_queries){ $queries = array();}


// Elementos Key "clave"
	// 0=> ID principal del elemento 1=> función a llamar despues, 2=> Recarga principal a llamar despues 3=> Validación de instrucción para no cerrar el Manage
$key_elements = array('main_tb_query_id','sudi_function_after', 'sudi_function_reload', 'sudi_function_stay');

// A) Incluimos las funciones y conexiones necesarias
require_once("../../_sudiEngine/_engine/config.php");
require_once("../../../../".$root_folder."/connectMySql.php");
include ("../../../../".$root_folder."/sudi_functions.php");
include ("../../_phpClasses/class.CurrentUser.inc");
include ("../../_phpClasses/class.Binnacle.inc");

$thisUser = new current_user;


// B) Establecemos ID Principal del registro
	// Este es un único datos POST, que no se utiliza en la generación de las consultas.
$main_id = ($_POST['main_tb_query_id']) ? $_POST['main_tb_query_id']: 0;
	
	// String que contiene el nombre de la funcion JS a llamar despues de insertar exitosamente
$function_after = 'no_set';

	// String que contiene el nombre de la lista o sección principal a recargar.
$reload_after = 'default';

	// String que indica si se cerrará el Manage al terminar
$manage_stay = 'true';

// C) Generamos el array $query_groups, que contiene la información completa de los registros a trabajar
	/* Ejemplo: [TABLE_ID] => Array([0] => TABLE, [1] => IF_FIELD, [2] => ACTION, [3] => ID_RECORD, [4] => MAIN / LINKED FIELD, [field_n] => DATA */
	
$query_groups = array();
foreach ($_POST as $key => $value){
	
	if($key != 'main_tb_query_id'){
		// SI- SON GRUPOS
		if(substr( $key, 0, 7 ) === "trecord"){
			$newA = explode('-SUDI-',$value	);
			$query_groups[$newA[0].'_'.$newA[3]] = $newA;
		// SI- SON CAMPOS
		}else{
			$toGroup = explode('-SUDI-',$key);
			//array_push($query_groups[$toGroup[0]][$toGroup[1]]);
			$query_groups[$toGroup[0]][$toGroup[1]] = $value;
		}
	}
}	

// Definimos que registros pasarán de "Add" a "Edit"
$addToEdit = array();
// Definimos la variable que cuenta cuantos registros se realizan
$numQuery = 0;
// LOOP para cada registro a trabajar
foreach ($query_groups as $group => $array){
	
	// Igualamos a 'nada' los valores antes de cada iteración
	$field = '';
	$values = '';
	$main_table = 0;
	
	// Validamos que el registro contenga más de los 5 elementos básicos
	if(count($query_groups[$group]) > 5){
		foreach ($query_groups[$group] as $key => $value)
			{
				// Los datos del 0 al 4 son los elementos base
				switch($key){
					case '0': // <-- Tabla de registro
						$table_key = $value;
					break;
					case '1': // <-- FIELD ID Principal del registro
						$primary_key = $value;
					break;
					case '2': // <-- Código único para este movimiento
						$action = $value;
					break;
					case '3': // <-- ID Princial del registro
						$id_key = $value;
					break;
					case '4': // <-- ID Princial del registro
						if(in_array('main_table',$query_groups[$group])){
							$main_table = 1;
						}else{
							$main_table = 0;
							$linked_field = $value;
						}
					break;
					// Los elementos siguientes son los campos y valores a trabajar en el registro.
					default:
						
					/* VALIDACIONES ESPECIALES */
						
						// [V1] Validamos si es campo de password, para encriptarlo
						if (strpos($key,'_password') !== false) { $value = sha1($value); }
						if (strpos($key,'_pass') !== false) { $value = sha1($value); }
						
						// [V2] Validamos si es campo de usuario actual
						if($value == 'theCurrentUser'){ $value = $thisUser->user_id; }
						
						// [V3] Validamos si debe eliminarse de archivo temporal
						
						if (substr($value, 0, 11) === '[temp_file]') {						
								$value = substr($value, 11);
																
								$query_rsDelete = sprintf("
									DELETE 
									FROM 
										sudi_temp_files 
									WHERE 
										file_path = %s;",
									GetSQLValueString($value,'text'));	
								mysqli_query($connectMySql,$query_rsDelete);
								
							}
						
						/* VALIDACIONES ESPECIALES [END] */
						
						// Si es un elemento válido
						if(!in_array($key,$key_elements)){
							if($action == 'edit'){
								
								$field .= $key . ' = ' . GetSQLValueString($value,(is_numeric($value)) ? 'text' : 'text' ).', ';	
							}else{
								$field .= $key . ', ';
								$values .= GetSQLValueString($value,(is_numeric($value)) ? 'text' : 'text' ).', ';
							}
						}else{
							if($key === 'sudi_function_after'){
								$function_after = $value; 
							}
							if($key === 'sudi_function_reload'){
								$reload_after = $value; 
							}
							if($key === 'sudi_function_stay'){
								$manage_stay = 'false'; 
							}
						}
					break;
				}
			} // foreach insert
		
			switch($action){
				case 'add':
					if($main_table){
						
						$query_rsSQL = sprintf("INSERT INTO %s (%s) VALUES (%s);", $table_key, substr($field, 0, -2), substr($values, 0, -2));
						
						if($debug && $debug_queries){ array_push($queries,$query_rsSQL); }												
						// Obtenemos el ID actual
						if(mysqli_query($connectMySql,$query_rsSQL)){
							$numQuery++;
							$main_id = mysqli_insert_id($connectMySql);	
							$newID  = $main_id;
						}
				
						// DEBUG if($debug && $debug_queries){ array_push($queries,$query_rsSQL,' ID_user: '.$Id_user,' Tabla: '.$table_key,' Campo Pal.: '.$primary_key,' Registro: '.$newID,' Acción: '.$action);}
						$Id_user=$thisUser->user_id;
						$thisBinaccle = new binnacle($Id_user,$table_key,$primary_key,$newID,$action);
					}else{
						
						$newFields = substr($field, 0, -2) . ', ' . $linked_field;
						$newValues = substr($values, 0, -2) . ', '. intval($main_id);
						$query_rsSQL = sprintf("INSERT INTO %s (%s) VALUES (%s);", $table_key, $newFields, $newValues);				
						
						if($debug && $debug_queries){ array_push($queries,$query_rsSQL); }
						
						if(mysqli_query($connectMySql,$query_rsSQL)){
							$numQuery++;
							$newID = mysqli_insert_id($connectMySql);
						}
						$Id_user=$thisUser->user_id;
						$thisBinaccle = new binnacle($Id_user,$table_key,$primary_key,$newID,$action);
						
					}
										
					//Registramos los registros Add para cambiarlos a Edit
					array_push($addToEdit,	$table_key.'-SUDI-'.$id_key.'-SUDI-'.$newID);
			break;
			case 'edit':
				$query_rsSQL = sprintf("UPDATE %s SET %s WHERE %s = %s;", $table_key, substr($field, 0, -2), $primary_key, $id_key);
				
				if($debug && $debug_queries){ array_push($queries,$query_rsSQL); }
				
				if(mysqli_query($connectMySql,$query_rsSQL)){
					$numQuery++;	
				}
				
				$Id_user=$thisUser->user_id;
				$thisBinaccle = new binnacle($Id_user,$table_key,$primary_key,$id_key,$action);
					
			break;	
		} // Switch Add o Edit (end)
		
	} // end if is valid
} // foreach group (end)
	


	if($debug){
	 	if($debug_queries){
			print_r($queries);
		}else{
			print_r($query_groups);		
		}
	exit;	
	}
	
	// Respuesta al cliente: a) Json con los registros agregados b) Error ene el proceso c) Solo edición
	echo ($addToEdit) ? json_encode(array(json_encode($addToEdit),$function_after,$reload_after,$manage_stay)): ((!$numQuery) ? json_encode(array('unsuccess',$function_after,$reload_after,$manage_stay)) : json_encode(array('justEdit',$function_after,$reload_after,$manage_stay)));
	exit;
?>