<?php

//error_reporting(E_ALL);
//ini_set('display_errors', 'on');
/*
	* list_engine.php
	* Gestiona las funciones necesarias para generar una lista.
	* Desarrollado por: Hugo Acosta Junio 2015
*/

// SESSION_START
	if (!isset($_SESSION)) {
		session_name('_upgrade');
		session_start();
	}

require_once('../../_sudiEngine/_engine/config.php');

// Si no se recicbe la carpeta a
if(!isset($_POST['folder'])){ echo "Especifique la carpeta"; exit; }

// incluimos la conexión a la base de datos
require_once('../../../../'.$root_folder.'/connectMySql.php');

// incluimos las funciones
require ("../../../../".$root_folder."/sudi_functions.php");

// incluimos la clase de comparación de fechas
require '../../_phpClasses/class.DateAgo.inc';

//incluimos la clase "current_user"
require '../../_phpClasses/class.CurrentUser.inc';
$thisUser = new current_user;

// requerimos la clase "Sections"
require '../../_phpClasses/class.Sections.inc';

// requerimos la clase "Privilegios"
require '../../_phpClasses/class.Privileges.inc';


// requerimos la clase "Switch"
require ('../../_phpClasses/class.Switch.inc');



// Objeto que contiene la nueva sección
$secInfo = new SudiSection;
$secInfo->set_section_info($_POST['folder']);

// Leemos los datos de la sección

$query_rsData = sprintf(
"SELECT
	sec_id, sec_list
FROM
	sudi_sections_tb
WHERE
	sec_folder = %s",
	GetSQLValueString($secInfo->folder, "text")
);

// Debug echo $query_rsData; exit;

$rsData = mysqli_query($connectMySql,$query_rsData);
$row_rsData = mysqli_fetch_assoc($rsData);
$totalRows_rsData = mysqli_num_rows($rsData);


	// Si no existe la lista
	if(!$totalRows_rsData){ echo "Not information"; exit; }

// Array que contiene los datos almacenados de la lista
$listInfo = explode("__,__",$row_rsData['sec_list']);

	/* debug	
	echo "<pre>";
		 print_r($listInfo);exit;
	echo "</pre>";

	*/
for ($i = 0; $i<count($listInfo); $i++){
		$newObject = new SudiList;
		$newObject = unserialize($listInfo[$i]);
		$listInfo[$i] = $newObject;
	}

	//debug	echo "<pre>" ; print_r($listInfo); echo "</pre>"; exit;

// <-- Hasta aqui, el array $listInfo contiene los campos autorizados a utilizar en el SUDI, los nombres a mostrar y los porcentajes a utilizar

// DEBUG echo '../../'.$_POST['folder'].'/config.php' ;exit;



/* == P R I V I L E G I O S == */

$idSection = $row_rsData['sec_id'];

	// Si no tiene privilegios para ver esta sección.
//if(!CheckPrivileges::getPrivileges("R",$idSection)){

	//include('../../_htmlAssets/not_allow.html');
	//exit;

//}


$listAuto = true;
$upBar = true;
$listNav = true;

// Incluimos las configuraciones necesarias.
include('../../'.$_POST['folder'].'/config.php');



// Incluimos el generador de listas y paginación

include('list_generator.php');


if($totalRows_rsData){

	// definimos que archivo cargar (list_auto.php / list.php)
	if($listAuto){
		include('../_engine/list_auto.php');
	}else{
		if(file_exists('../../'.$secInfo->folder.'/list.php')){
			include('../../'.$secInfo->folder.'/list.php');
		}else{
			echo "Error: No existe el archivo list.php";
		}
	}

}else{
	if($list_anyway){

		if(file_exists('../../'.$secInfo->folder.'/list.php')){
			include('../../'.$secInfo->folder.'/list.php');
		}else{
			echo "Error: No existe el archivo list.php";
		}

	}elseif(!$_POST['noUpBar']){
	echo "<p>Without information</p>";
	}else{
	echo "Not found";
	}


}

// List Row Options && List Navigation
	// Agregamos el apartado de opciones (click derecho) y cuadro de navegación

?>

<div id="list_row_options" data-folder="<?php echo $secInfo->folder; ?>" data-table="<?php echo $secInfo->table; ?>">

    <?php
	if($thisListOptions){

		for($i=0; $i<count($thisListOptions);$i++){
		//array('titulo','icono','target','content')
		?>

		<li class="<?php echo ($thisListOptions[$i][2] == 'r_panel') ? 'loadRContent': 'loadContent'; ?> list_row_special_options <?php ?>"
    	data-target="<?php echo $thisListOptions[$i][2]; ?>"
        data-content="<?php echo $thisListOptions[$i][3]; ?>"
        data-post="<?php echo ($thisListOptions[$i][4]) ? $thisListOptions[$i][4]: ''; ?>"><p><?php echo $thisListOptions[$i][0]; ?></p> <i class="icon icon-iconos-sudi-<?php echo $thisListOptions[$i][1]; ?>"></i></li>
		<?php
		} // for each special (end)

	} // special list options end
	?>


    <?php if(!$noEdit){ ?>
    <li id="list_row_edit_item" class="loadContent"
    	data-target="curtain"
        data-content="_sudiEngine/_engine/manage_engine.php"
        data-post=""><p>Edit</p> <i class="icon icon-iconos-sudi-edit"></i></li>
    <?php } ?>

    <?php if(!$noComment){ ?>

    <li id="list_row_comment_item" class="comment_btn"
        ><p>Comments</p> <i class="icon icon-iconos-sudi-messages-chat"></i></li>
    <?php } ?>


    <?php if(!$noDelete){

	//if(CheckPrivileges::getPrivileges("D",$idSection)){
	?>
    <li id="list_row_delete_item"
    	data-target="curtain"
        data-content="_sudiEngine/_engine/manage_engine.php"
        data-post=""><p>Delete</p> <i class="icon icon-iconos-sudi-delete"></i></li>
    <?php
		//}
	}

	?>


</div><!-- list_row_options -->

<?php if($listNav){ ?>


<!--<script type="text/javascript">

	var postData = {var1:1,var2:'dos'};

	loadContent($('#nav_list_containr'),'_sudiEngine/_engine/nav_list.php',postData)
</script>-->

<div id="nav_list">
	<!--<div id="page_num">
    	<span>5</span>
    </div>-->

	<?php 
    // Criterio de búsqueda
	$postSearch = ($_POST['list_search']) ? "_&_list_search_:_1_&_search_data_:_".$_POST['search_data']."_&_search_tb_:_".$_POST['search_tb']."_&_noUpBar_:_1": '';	
	
	$fixedId = ($_POST['fixedId']) ? "_&_fixedId_:_".$_POST['fixedId'] : '';
	?>
    
    	<?php if($total_pages > 3){ ?>
        <div 
         	class="nav_list_btn  <?php if($prev_page){ echo 'loadContent';}else{ echo "disabled"; }?>"  
            data-target="main" 
            data-content="_sudiEngine/_engine/list_engine.php" 
            data-post="folder_:_<?php echo $secInfo->folder; ?>_&_current_page_:_<?php echo '1' . $postSearch."_&_noUpBar_:_1".$fixedId; ?>">
            <i class="icon icon-iconos-sudi-arrow-left-13" style="margin-right:-8px;"></i><i class="icon icon-iconos-sudi-arrow-left-13"></i>
        </div>
    	<?php } ?>
		<div 
         	class="nav_list_btn  <?php if($prev_page){ echo 'loadContent';}else{ echo "disabled"; }?>"  
            data-target="main" 
            data-content="_sudiEngine/_engine/list_engine.php" 
            data-post="folder_:_<?php echo $secInfo->folder; ?>_&_current_page_:_<?php echo $prev_page . $postSearch."_&_noUpBar_:_1".$fixedId; ?>">
            <i class="icon icon-iconos-sudi-arrow-left-13"></i>
        </div>
        <div 
        	class="nav_list_btn <?php if($next_page){ echo 'loadContent';}else{ echo "disabled"; }?>"  
            data-target="main" 
            data-content="_sudiEngine/_engine/list_engine.php" 
            data-post="folder_:_<?php echo $secInfo->folder; ?>_&_current_page_:_<?php echo $next_page . $postSearch."_&_noUpBar_:_1".$fixedId; ?>">
            <i class="icon icon-iconos-sudi-arrow-right-13"></i>
        </div>
        <?php if($total_pages > 3){ ?>
         <div 
        	class="nav_list_btn <?php if($next_page){ echo 'loadContent';}else{ echo "disabled"; }?>"  
            data-target="main" 
            data-content="_sudiEngine/_engine/list_engine.php" 
            data-post="folder_:_<?php echo $secInfo->folder; ?>_&_current_page_:_<?php echo $total_pages . $postSearch."_&_noUpBar_:_1".$fixedId; ?>">
            <i class="icon icon-iconos-sudi-arrow-right-13"></i>
            <i class="icon icon-iconos-sudi-arrow-right-13" style="margin-left:-12px;"></i>
        </div>
    	<?php } ?>
    <div id="page_info">
    	<?php if($theWeek){ ?>
    	<span>Semana <?php echo $theWeek; ?> | <?php echo $theYear; ?></span>
    	<?php }elseif($theMonth){
		$dateObj   = DateTime::createFromFormat('!m', $theMonth);
		$monthName = strftime('%B', $dateObj->getTimestamp());
		?>
    	<span><?php echo $monthName; ?> | <?php echo $theYear; ?></span>
    	<?php }else{ ?>
		<span>Pág. <?php echo $current_page; ?> de <?php echo $total_pages; echo ($listOnSearch) ? '  <span class="loadContent list_search_clean"  data-target="main" data-content="_sudiEngine/_engine/list_engine.php" data-post="folder_:_'.$_POST['folder'].'_&_search_clean_:_true"><i class="icon icon-iconos-sudi-delete"></i> Borrar filtro</span>': ''; ?></span>
		<?php } ?>
    </div>
</div><!-- Nav List (end) -->


<?php  } // IF - ListNav?>
<?php
if($upBar){
	// Si existe información de búsqueda)
	if(!$_POST['noUpBar']){

		echo '<div class="silence simultaneousLoad" data-target="upbar" data-content="_sudiEngine/_engine/upBar_generator.php" data-post="folder_:_' . $secInfo->folder . (($listOnSearch) ? '_&_list_search_:_true': '').'"></div>';
	}
}

?>